/*
** Copyright (c) 1992, 1993-2001 by Wayne E. Wright, W5XD, Round Rock, Texas
** All rights reserved.
*/
#include "stdafx.h"
#include "WlogRigs.h"
#include "Rig.h"
#include "rwrig.h"
#include "DrvTable.h"

/////////////////////////////////////////////////////////////////////////////
// CRigBase
CRigBase::~CRigBase()
{
	if (m_State.m_pCommChannel)
		m_State.m_pCommChannel->Release();
}


STDMETHODIMP CRigBase::PutCommPort(IWlRigIO *pChan, long Index)
{
	if (m_State.m_pCommChannel)
		m_State.m_pCommChannel->Release();
	m_State.m_pCommChannel = pChan;
	if (m_State.m_pCommChannel)
		m_State.m_pCommChannel->AddRef();
	m_Index = Index;
	return S_OK;
}


STDMETHODIMP CRigBase::GetFrequency(
									double *pXmit,
									double *pRcv,
									short *pMode,
									short *pPrimaryVFO,
									short *pSplit)
{
		*pXmit = m_LastFreq.Xmit;
		*pRcv = m_LastFreq.Rcv;
		*pMode = m_LastFreq.Mode;
		*pPrimaryVFO = m_LastFreq.PrimaryVFO;
		*pSplit = m_LastFreq.Split;
		return S_OK;
}

STDMETHODIMP CRigBase::TuneFrequency(long Amount, long *pVal)
{
	m_LastFreq.Rcv += (Amount / 1000.0);
	if (!m_LastFreq.Split)
		m_LastFreq.Xmit = m_LastFreq.Xmit;
	return Set(m_LastFreq.Xmit,
			m_LastFreq.Rcv,
			m_LastFreq.Mode,
			m_LastFreq.PrimaryVFO,
			m_LastFreq.Split,
			pVal);
}


