/*
** Copyright (c) 1992, 1993-2001 by Wayne E. Wright, W5XD, Round Rock, Texas
** All rights reserved.
*/
// Rig.h : Declaration of the CRig

#ifndef __RIG_H_
#define __RIG_H_

#include "resource.h"       // main symbols
#include "rigdisp.h"

//CRigBase
// This class implements the basics that pretty much any rig driver
// would have to d.
class ATL_NO_VTABLE CRigBase : public IWlRig
{
public:
	CRigBase()
	{
		memset(&m_State, 0, sizeof(m_State));
		memset(&m_LastFreq, 0, sizeof(m_LastFreq));
		m_LastFreq.Mode = 1;
		m_LastFreq.PrimaryVFO = 0;
		m_LastFreq.Split = 0;
		m_Index = -1;
	}

	STDMETHOD(PutCommPort)(IWlRigIO *pChannel, long Index);
	STDMETHOD(GetFrequency)(
			double *pXmit,
			double *pRcv,
			short *pMode,
			short *pPrimaryVFO,
			short *pSplit);
	STDMETHOD(TuneFrequency)(long Amount, long *pVal);

protected:
	~CRigBase();
	struct DrvState	m_State;
	struct freq_stru	m_LastFreq;
	long	m_Index;
};


#endif //__RIG_H_
